# Generated by sila2.code_generator; sila2.__version__: 0.12.2
# -----
# This class does not do anything useful at runtime. Its only purpose is to provide type annotations.
# Since sphinx does not support .pyi files (yet?), this is a .py file.
# -----

from __future__ import annotations

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from typing import Iterable, Optional

    from influxdbcontroller_types import (
        CreateToken_Responses,
        QueryInfluxDB_Responses,
        SetBucket_Responses,
        SetOrganisation_Responses,
        SetToken_Responses,
    )
    from sila2.client import ClientMetadataInstance, ClientUnobservableProperty


class InfluxDBControllerClient:
    """
    InfluxDB Controller
    """

    Token: ClientUnobservableProperty[str]
    """
    Get Current InfluxDB Token
    """

    Organisation: ClientUnobservableProperty[str]
    """
    Get Current InfluxDB Organisation
    """

    Bucket: ClientUnobservableProperty[str]
    """
    Get Current InfluxDB Bucket
    """

    def CreateToken(
        self, Token: str, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> CreateToken_Responses:
        """
        Create New Token for InfluxDB
        """
        ...

    def SetToken(
        self, Token: str, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetToken_Responses:
        """
        Set Token for InfluxDB
        """
        ...

    def SetOrganisation(
        self, Organisation: str, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetOrganisation_Responses:
        """
        Set Organisation in InFluxDB
        """
        ...

    def SetBucket(
        self, Bucket: str, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetBucket_Responses:
        """
        Set InfluxDB bucket
        """
        ...

    def QueryInfluxDB(
        self, Query: str, QueryResultType: str, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> QueryInfluxDB_Responses:
        """
        Query InfluxDB in flux query language
        """
        ...
